//+------------------------------------------------------------------+
//|                                                   Phoenix_v1.mq4 |
//|                                       Copyright  2006, Hendrick |
//|A part of Phoenix is based on the EA Firebird made by TraderSeven |
//|Some parts of the code of Phoenix are made by others. If the maker| 
//|of the code was known I've mentioned their names.                 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Hendrick."



//---- input parameters
extern int        MA_Length        = 10;
extern int        MA_Timeframe     = 15;
extern double     Lots             = 1;
extern bool       MM               = true; 
extern bool       AccountIsMicro   = false; 
extern int        SafePipsMinutes  = 240;
extern int        SafePipsDistance = 60;
extern double     Percent          = 0.05;
extern double     SafeArea         = 50;
extern int        Risk             = 5; 
extern int        TakeProfit       = 18;
extern int        StopLoss         = 42;
extern int        TrailingStop     = 0;
extern bool       UseCloseSignal   = true;
extern int        TradeFrom1       = 8;
extern int        TradeUntil1      = 12;
extern int        TradeFrom2       = 13;
extern int        TradeUntil2      = 15;
extern int        TradeFrom3       = 16;
extern int        TradeUntil3      = 18;
extern int        TradeFrom4       = 19;
extern int        TradeUntil4      = 22;
extern bool       WantToGamble     = true;
extern int        GambleFrom       = 16;
extern int        GambleUntil      = 17;
extern int        GambleFactor     = 3;
extern bool       UseSurf          = true;
extern bool       UseDivergence    = false;
extern int        Fast_Period      = 23;
       int        Fast_Price       = PRICE_OPEN;
extern int        Slow_Period      = 84;
       int        Slow_Price       = PRICE_OPEN;
extern double     DVBuySell        = 0.0011;
extern double     DVStayOut        = 0.0079;




//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {


   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
//=============== CHECK CHART NEED MORE THAN 100 BARS
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }
   
      
//=============== ADJUST LOTS IF MM=TRUE/

   if(MM) Lots = subLotSize();
   
      
//=============== ADJUST LOTS IF YOU WANT TO GAMBLE (IDEA MarvinSK)

   if(WantToGamble==true)
      {
         int ht=TimeHour(LocalTime());
         if((ht >= GambleFrom) && (ht <= (GambleUntil-1)))
            {
            Lots = (GambleFactor*subLotSize());
            }
      }
      
//===============  START SAFEPIPDISTANCE
  
   bool SafeTotalPips = false;
   double valTOT;

   int k=(SafePipsMinutes/MA_Timeframe);
   valTOT=(High[Highest(NULL,0,MODE_HIGH,k,0)]) - (Low[Lowest(NULL,0,MODE_LOW,k,0)]);

   if(Point==0.01) 
      valTOT=MathAbs(valTOT)*100;
   if(Point==0.0001) 
      valTOT=MathAbs(valTOT)*10000;
   if(valTOT<=SafePipsDistance)
      SafeTotalPips=true;
//   Comment("valTOT= ",valTOT);
   
   

//=============== START DIVERGENCE     

   bool DivergeBuy=false;
   bool DivergeSell=false;
  
   double diverge=divergence(Fast_Period,Slow_Period,Fast_Price,Slow_Price,0);
   if( diverge>=DVBuySell        && diverge<=DVStayOut )         DivergeBuy=true;
   if( diverge<=(DVBuySell*(-1)) && diverge>=(DVStayOut*(-1)) ) DivergeSell=true;
   if(UseDivergence==false)
      {
       DivergeBuy=true;
       DivergeSell=true;
      } 

//=============== START VALID TRADE TIME

   int iHour=TimeHour(LocalTime());
   int ValidTradeTime = F_ValidTradeTime(iHour);
   
   
//=============== START REGULAR SELL/BUY SIGNALS   

   int    TE  = 0;
   double MA  = 0;
   double RVI = 0;
   
   MA =iMA(NULL,MA_Timeframe,MA_Length,0,MODE_SMA,PRICE_OPEN,0);
   RVI=iRVI(NULL,0,10,MODE_MAIN,0)-iRVI(NULL,0,10,MODE_MAIN,1);

   TE=iBullsPower(NULL,0,20,6,0)+iBearsPower(NULL,0,20,6,0);
   if(Point==0.01)   TE=TE*100;
   if(Point==0.0001) TE=TE*10000;
   if((TE>-SafeArea) && (TE<SafeArea)) TE=1;

   bool SellOk, BuyOk;
   if((MA*(1+Percent/100))<Bid && RVI<0 && TE==1 && ValidTradeTime==1 && SafeTotalPips==true && DivergeSell==true) SellOk=true;
   if((MA*(1-Percent/100))>Ask && RVI>0 && TE==1 && ValidTradeTime==1 && SafeTotalPips==true && DivergeBuy==true) BuyOk=true;


//=============== START SURF SELL/BUY SIGNALS   

   bool SURFSellOk=false, SURFBuyOk=false, SurfUP=false, SurfDOWN=false;
   
   if((MA*(1+Percent/100))<Bid && SafeTotalPips==false) SURFBuyOk=true;
   if((MA*(1-Percent/100))>Ask && SafeTotalPips==false) SURFSellOk=true;

   double dOpenClose = (iOpen(NULL,PERIOD_M5,1) - iClose(NULL,PERIOD_M5,1));
   if(dOpenClose > 0){SurfDOWN = true;}
   else {SurfUP = true;}
   
     
   
//=============== START CLOSE SIGNALS

   bool CLOSEBuyOrder=false;
   bool CLOSESellOrder=false;
   if((MA*(1+Percent/100))<Bid && RVI<0) CLOSEBuyOrder=true;
   if((MA*(1-Percent/100))>Ask && RVI>0) CLOSESellOrder=true;
        

     
//=================== START REGULAR ORDERS ========================================================   

   int cnt, ticket, total, OrderIsOpen=0;
   total  = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderSymbol()==Symbol())&& (OrderMagicNumber()==12345))
         {
         OrderIsOpen=1;
         break;
         }
      else
         continue; 
      }  
    if(OrderIsOpen==0) 
      {
      if(BuyOk==true) 
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"Phoenix REGULAR",12345,0,GreenYellow);
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
            }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }

      if(SellOk==true)
         {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"Phoenix REGULAR",12345,0,Red);
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
      }
     
               
//=============== CHECK CLOSE/TRAILING STOP REGULAR ORDERS  
   total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderType() <= OP_SELL) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == 12345))
         {
         if(OrderType() == OP_BUY)
            {
            if(TrailingStop > 0)
               {
               if((Bid-OrderOpenPrice()) > (Point*TrailingStop))
                  {
                  if((OrderStopLoss()) < (Bid-Point*TrailingStop))
                     {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,GreenYellow);
                     return(0);
                     }
                  } 
               }                  
 
               if((UseCloseSignal == true) && (CLOSEBuyOrder == true))
                  {
                  OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
                  return(0); 
                  }
             }

            if(OrderType() == OP_SELL)
               {
               if(TrailingStop > 0)
                  {
                  if(OrderOpenPrice()-Ask>Point*TrailingStop)
                     {
                     if(OrderStopLoss()>Ask+Point*TrailingStop)
                        {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                        return(0);              
                        }
                     }     
                  }
               if((UseCloseSignal == true) && (CLOSESellOrder == true))
                  {
                  OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
                  return(0); 
                  }

                }
             }
          }

          
//=============== START SURFORDERS 

   int SurfOrderOpen=0;
   total  = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderSymbol()==Symbol()) && (OrderMagicNumber()==98989))
         {
         SurfOrderOpen=1;
         break;
         }
      else
         continue;
      }          
   if((SurfOrderOpen==0) && (UseSurf==true))
      {
      if((SURFBuyOk==true) && (SurfUP==true)) 
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"Phoenix SURF",98989,0,LightBlue);
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY SURF order opened : ",OrderOpenPrice());
            }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }
      if((SURFSellOk==true) && (SurfDOWN==true))
         {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"Phoenix SURF",98989,0,Yellow);
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL SURF order opened : ",OrderOpenPrice());
            }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
      }
 


//=================== END SURFORDERS =============================================================
Comment("SafeTotalPips= ",SafeTotalPips,"\n","ValidTradeTime= ",ValidTradeTime,"\n","TE= ",TE,"\n","OrderIsOpen= ",OrderIsOpen,"\n"," valTOT= ",valTOT);

//==================THIS IS THE END
}      

//+------------------------------------------------------------------+
//| expert functions                                                 |
//+------------------------------------------------------------------+


//=============== FUNCTION VALID TRADE TIME

int F_ValidTradeTime (int iHour)
   {
      if(((iHour >= TradeFrom1) && (iHour <= (TradeUntil1-1)))||((iHour>= TradeFrom2) && (iHour <= (TradeUntil2-1)))||((iHour >= TradeFrom3)&& (iHour <= (TradeUntil3-1)))||((iHour >= TradeFrom4) && (iHour <=(TradeUntil4-1))))
      {
       return (1);
      }
      else
       return (2);
   }  

//=============== FUNCTION DIVERGENCE
  
double divergence(int F_Period, int S_Period, int F_Price, int S_Price, int mypos)
  {

   int i;
   
   double maF1, maF2, maS1, maS2;
   double dv1, dv2;
   
   maF1=iMA(Symbol(),0,F_Period,0,MODE_SMA,F_Price,mypos);
   maS1=iMA(Symbol(),0,S_Period,0,MODE_SMA,S_Price,mypos);
   dv1=(maF1-maS1);

   maF2=iMA(Symbol(),0,F_Period,0,MODE_SMA,F_Price,mypos+1);
   maS2=iMA(Symbol(),0,S_Period,0,MODE_SMA,S_Price,mypos+1);
   dv2=(maF2-maS2);
     
   return(dv1-dv2);
   
  }
//=============== FUNCTION MONEY FUNCTION (SOURCE : CODERSGURU)

double subLotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
	  
	  if(AccountIsMicro==false) //normal account
	  {
	     if(lotMM < 0.1)                  lotMM = Lots;
	     if((lotMM > 0.5) && (lotMM < 1)) lotMM = 0.5;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  else //micro account
	  {
	     if(lotMM < 0.01)                 lotMM = Lots;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  
	  return (lotMM);
}




//=============== FUNCTION PREVENT "TRADE CONTEXT BUSY" ERROR 146
//=============== SOURCE: metaquotes.net



//+------------------------------------------------------------------+

